﻿//TL Conflict Resolution#10
function getTutorialSteps() {
    return [
        function() {
            tutorial.text = qsTr("安装 Mod 时你可能遇到各种各样的冲突。"
                                +"本教程将尽可能的介绍所有你可能遇到的冲突以及对应的解决办法。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("首先是文件冲突，这些通常发生在两个 Mod 之间存在相同的文件。"
                                +"最常见的情况是多个 Mod 都替换了游戏中的相同文件，比如某件铠甲的材质。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("比如：你要安装的 \"ModA\" 包含了时髦的铁质和皮革铠甲。"
                                +"而另一个 \"ModB\" 包含了性感的乌木和皮革铠甲。很明显地"
                                +"两个 Mod 存在冲突：要使用哪个皮革铠甲？")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("如果你是手动安装 Mod ，那么安装 \"ModB\" 时系统会提示是否覆盖文件。"
                                 +"如果你选择了是，你的皮革铠甲将来自于 \"ModB\" ，否则就是 \"ModA\" 的"
                                 +"如果后来你发现自己选择错了，你就必须重新安装 Mod。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("如果你使用 MO 安装 Mod ，那么 ModA 和 ModB 的内容都会安装"
                                 +"但游戏中仅加载 \"ModB\" ，因为他的优先级最高。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("然而，任何时候你都可以在列表中通过拖放修改 Mod 优先级。"
                                 +"如果你标记 \"ModA\" 为更高优先级，皮革铠甲将由它提供。"
                                 +"你甚至不需要重新安装 Mod 。因为此列表中 Mod 的优先级近"
                                 +"似于 Mod 的安装顺序，所以我更倾向于称之为 \"安装顺序\"。")
            highlightItem("modList", false)
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("如果 \"标记\" 列已开启，列表中将显示哪个 Mod 存在冲突以及如何如何...")
            waitForClick()
        },
        function() {
            unhighlight()
            tutorial.text = qsTr("<img src=\":/MO/gui/emblem_conflict_overwrite\" /> 表示 Mod 覆盖了其他 Mod 里面的文件。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("<img src=\":/MO/gui/emblem_conflict_overwritten\" />  表示 Mod 的<b>部分文件</b>被其他 Mod 给覆盖了。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("<img src=\":/MO/gui/emblem_conflict_mixed\" /> 表示以上两种情况都出现了。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("<img src=\":/MO/gui/emblem_conflict_redundant\" /> 表示该 Mod 完全被其他 Mod 给覆盖了，你可以直接禁止掉该 Mod 。");
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("这边有两种方法可以用来查看冲突文件中的个别文件：")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("方案 A：切换到 \"Data\" 标签")
            if (!tutorialControl.waitForTabOpen("tabWidget", 2)) {
                highlightItem("tabWidget", false)
                waitForClick()
            } else {
                highlightItem("tabWidget", true)
            }
        },
        function() {
            tutorial.text = qsTr("... 在这边，如果你设置了高亮显示，文件树将金显示冲突的文件。"
                                 +"在右边那一列中，显示的是文件来自于哪个 Mod (因为优先级最高)"
                                 +"把鼠标移到文件上面，则会显示所有包含该文件的 Mod 。")
            highlightItem("conflictsCheckBox", false)
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("方案 B：打开<b>已开启</b>的 Mod 的<i>信息</i>对话框"
                                 +"，具体方法为直接双击或者右键，选择<i>信息...</i>")
            highlightItem("modList", true)
            manager.activateTutorial("ModInfoDialog", "tutorial_conflictresolution_modinfo.js")
            applicationWindow.modInfoDisplayed.connect(nextStep)
        },
        function() {
            unhighlight()
            tutorial.text = qsTr("这就是文件冲突的大概内容，"
                                +"第二种冲突类型为\"档案冲突\"。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("在\"第一步\"教程中，我们提到了 esp/esm 插件是如何修改游戏中的内容，"
                                 +"比如修改地形或者已存在的NPC。而每一个这种修改都以档案形式保存。这就"
                                 +"是\"档案冲突\"。例如：两个 Mod 都修改了同一个场景，但是只有一个会生效。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("与文件冲突类似的，你没法修复这些冲突，你必须选择你要的内容。"
                                 +"如果你选择错误了，你的游戏将变得不是很稳定，因为某些 mod 需"
                                 +"要特定的档案才能正常工作。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("打开\"ESPs\"标签...")
            highlightItem("tabWidget", true)
            if (!tutorialControl.waitForTabOpen("tabWidget", 0)) {
                nextStep()
            }
        },
        function() {
            tutorial.text = qsTr("你依旧可以使用拖放来修改插件的优先级，从而决定哪个插件处于冲突的最高级，"
                                 +"这个通常被称作\"加载顺序\"。但是，你怎么知道如何设置插件的顺序最佳？")
            waitForClick()
        },
        function() {
            unhighlight()
            tutorial.text = qsTr("与文件冲突不同的，MO 没法提供此类冲突的详细信息。但是你可以借助 BOSS 。"
                                 +"BOSS 是一款优秀的排序工具，你可以从N网下载并且灵巧地整合到 MO 里面。"
                                 +"基本上，如果你还没有 BOSS 的，那么请在此教程结束后安装。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("把 BOSS 安装到默认位置后(参考介绍)，开启 MO ，BOSS 便会自动添加到可执行程序...")
            highlightItem("startGroup", false)
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("运行 BOSS 后，它将重新调整插件的顺序，以达到最佳的兼容性(会覆盖你手动的修改)。"
                                 +"最后会打开一个网页报告，里面会提示你存在的冲突。强烈建议认真阅读该报告。")
            waitForClick()
        },
        function() {
            unhighlight()
            tutorial.text = qsTr("最后一种冲突也是 \"档案冲突\"，与前一个类型类似。因为名字一样，容易混乱，"
                                 +"所以我把它称作 \"列表冲突\"。区别在于冲突的档案类别。这种冲突是能够整合的"
                                 +"从而你可以在游戏中看到所有的修改。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("一个常见的例子是等级列表，也就是那些定义特定级别下刷新出来的物品的列表。"
                                 +"传统上，如果多个 Mod 都修改了这种列表，最终只有一个会生效...")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("... 但我们有工具可以整合这些 Mod ，从而可以实现所有的效果。"
                                 +"不过此功能并不包括在 MO 里面，因为该工具已经很强大了。"
                                 +"对 Oblivion 与 Skyrim，你可以使用 wrye bash 。"
								 +"对 fallout 3/nv，你可以使用 wrye flash。"
                                 +"对 Skyrim ，你还可以使用 \"SkyBash\"。"
								 +"这些工具都可以创建一个名为 \"bashed patch\" 的插件"
                                 +"里面包含了所有你的插件中所有可整合的内容。")
            waitForClick()
        },
        function() {
            tutorial.text = qsTr("你完成了教程的学习。")
            waitForClick()
        }

    ]
}
